open System.Linq

let twogents =  @".\THE TWO GENTLEMEN OF VERONA.txt" //update to your play file
let twogents_out = @".\gentlmenverona_processed4.txt" //upate to your output file


let crunch source = 
    let text = System.IO.File.ReadAllText(source)
    let matches = System.Text.RegularExpressions.Regex.Matches(text,@"((ACT|Act)((.|\n)+?)(?=(\n((ACT|Act)|THE END| +?-THE END-))))");
    System.Console.WriteLine("Acts {0}",matches.Count)
    let values = matches.Cast<System.Text.RegularExpressions.Match>().Select((fun m -> m.Value)).ToArray();
    let actLines = System.String.Join("\n",values |> Array.mapi (fun i act ->
                            let sAct = act + "\n!ACT END!"//Add this so it's easy to cap off the scenes
                            let sceneMatches = System.Text.RegularExpressions.Regex.Matches(sAct,@"(Scene|SCENE)\s[IV\d]+((.|\n)+?)(?=((Scene|SCENE)\s[IV\d]+|!ACT END!))",System.Text.RegularExpressions.RegexOptions.Multiline)
                            let sceneValues = sceneMatches.Cast<System.Text.RegularExpressions.Match>().Select((fun m -> m.Value)).ToArray();
                            let sceneLines = System.String.Join("\n",sceneValues |> Array.mapi (fun j scene -> 
                                let sScene = scene + "\n!SCENE END!"
                                let speechLines = System.Text.RegularExpressions.Regex.Matches(sScene,@"(  |    |   )[\[\w].+")
                                let speechValues = speechLines.Cast<System.Text.RegularExpressions.Match>().Select((fun m -> m.Value)).ToArray();
                                let speechOnly = System.String.Join("",speechValues)
                                let combinedSpeech = System.Text.RegularExpressions.Regex.Replace(speechOnly,"[\r\n](    |   )(?=[\[\w])"," ")
                                let leftShift = System.Text.RegularExpressions.Regex.Replace(combinedSpeech,"(  (?=\w))","")
                                let noBraces = System.Text.RegularExpressions.Regex.Replace(leftShift," *?\[[^\]]+?\] *"," ")
                                let flattenedSpeech = System.Text.RegularExpressions.Regex.Replace(noBraces,"( {2,100}[\w\.]+|Exeunt\.)","")
                                let addDelim = System.Text.RegularExpressions.Regex.Replace(flattenedSpeech,"(?<=(^|[\r\n])[^\.]+?)\.[ ,]?","|")
                                let trimmed = System.Text.RegularExpressions.Regex.Replace(addDelim," +?\|","|")
                                let addActScene = System.Text.RegularExpressions.Regex.Replace(trimmed,"(^|[\r\n])(?=\w)",System.String.Format("\n{0}|{1}|",(i+1),(j+1)))
                                let replacedRforN = System.Text.RegularExpressions.Regex.Replace(addActScene,"[\r\n]+","\n")
                                let removeQuotes = System.Text.RegularExpressions.Regex.Replace(replacedRforN,"\"","")
                                let splitLines = removeQuotes.TrimStart().Split('\n')
                                let numberdLines = splitLines
                                                    |> Array.filter (fun l -> l.Length>0)
                                                    |> Array.mapi (fun k l-> System.String.Format("{0}|{1}|{2}",k,System.Math.Round((float k/float(splitLines.Count())),4),l))
                                System.String.Join("\n",numberdLines)
                            ))
                            let splitLines = sceneLines.Split('\n')
                            let numberdActLines = splitLines
                                                   |> Array.filter (fun l -> l.Length>0)
                                                   |> Array.mapi (fun k l-> System.String.Format("{0}|{1}|{2}",k,System.Math.Round((float k/float(splitLines.Count())),4),l))
                            System.String.Join("\n",numberdActLines)
                          )
              )
    let splitLines = actLines.Split('\n')
    let numberdPlayLines = splitLines
                           |> Array.filter (fun l -> l.Length>0)
                            |> Array.mapi (fun k l-> System.String.Format("{0}|{1}|{2}",k,System.Math.Round((float k/float(splitLines.Count())),4),l))
    System.String.Join("\n",numberdPlayLines)
let gentlemen= crunch twogents
System.IO.File.WriteAllText(twogents_out,gentlemen)